﻿Type=Activity
Version=3.5
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	Dim Mode As String
End Sub

Sub Globals
	Dim lbl() As Label
	Dim edt() As EditText
	Dim scvEdit As ScrollView
	Dim btnAdd, btnDelete, btnUpdate, btnPrevious, btnNext, btnFirst, btnLast As Button
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("Edit")
	Activity.Title = "SQLiteLight3  Edit"
	
	InitEditPanel
End Sub

Sub Activity_Resume
	If Main.CurrentIndex > -1 Then
		ShowEntry(Main.CurrentIndex)				'show the first entry
	End If
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub ShowEntry(EntryIndex As Int)
	Dim Cursor1 As Cursor
	Dim i, ID As Int
	
	If Main.IDList.Size = 0 Then 			'check if database is empty
		Return													'if the database is empty leave the routine
	End If
	
	If Mode = "Add" Then
		For i = 0 To Main.ColNumber - 1
			edt(i).Text = ""
		Next
	Else
		ID = Main.IDList.Get(EntryIndex)		'get the ID for the given entry index
		'read the entry with the given ID
		Cursor1 = Main.SQL1.ExecQuery("SELECT * FROM " & Main.SQLTabelName & " WHERE ID = " & ID)	
		Cursor1.Position = 0
		For i = 0 To Main.ColNumber - 1
			edt(i).Text = Cursor1.GetString2(i)
		Next
		Cursor1.Close												'close the cursor, we don't it anymore
	End If
	ShowButtons
End Sub

Sub AddEntry
	Dim Query As String
	Dim Cursor1 As Cursor
	Dim i, ID As Int
	Dim Values As List
	
	'first we check if the entry already does exist
	Query = "SELECT * FROM " & Main.SQLTabelName & " WHERE "
	
'	Values.Initialize
	Dim Vals(Main.ColNumber - 1) As String
	For i = 1 To Main.ColNumber - 1
		If i = 1 Then
			Query = Query & Main.ColNames(i) & " = ?"
		Else
			Query = Query & " AND " & Main.ColNames(i) & " = ?"
		End If
		Vals(i - 1) = edt(i).Text
	Next
	Cursor1 = Main.SQL1.ExecQuery2(Query, Vals)

	If Cursor1.RowCount > 0 Then
		'if it exists show a message and do nothing else
		ToastMessageShow("This entry already exists", False)
	Else
		'if not, add the entry
		'a NULL for the ID column increments the primary key automatically by one
		'we use ExecNonQuery2 because it's easier, we don't need to take care of the data types 
		Query = "INSERT INTO " & Main.SQLTabelName & " VALUES (NULL"
		Values.Initialize
		For i = 1 To Main.ColNumber - 1
			Query = Query & ", ?"
			Values.Add(edt(i).Text)
		Next
		Query = Query & ")"
		Main.SQL1.ExecNonQuery2(Query, Values)
		
		ToastMessageShow("Entry added", False)	' confirmation for the user
		
		'to display the ID of the last entry we read the max value of the ID column 
		ID = Main.SQL1.ExecQuerySingleResult("SELECT max(" & Main.ColNames(0) & ") FROM " & Main.SQLTabelName)
		Main.RowNumber = Main.RowNumber + 1					'increase the row count
		Main.IDList.Add(ID)										'add the last ID to the list
		Main.CurrentIndex = Main.IDList.Size - 1		'set the current index to the last one
		edt(0).Text = ID										'display the last index
	End If
	Cursor1.Close												'close the cursor, we don't it anymore
	
	ShowButtons
End Sub

Sub DeleteEntry
	Dim Question, Query As String
	Dim i, Answ As Int
	
	'ask the user for confirmation
	Question = "Do you really want to delete " 
	For i = 1 To Main.ColNumber - 1
		Question = Question & CRLF & edt(i).Text
	Next
	Answ = Msgbox2(Question, "Delete entry", "Yes", "", "No", Null)

	If Answ = DialogResponse.POSITIVE Then						'if yes, delete the entry
		Query = "DELETE FROM " & Main.SQLTabelName & " WHERE " & Main.ColNames(0) & " = " & Main.IDList.Get(Main.CurrentIndex)
		Main.SQL1.ExecNonQuery(Query)										'delete the entry
		Main.IDList.RemoveAt(Main.CurrentIndex)					'remove the ID from the list
		If Main.CurrentIndex = Main.RowNumber - 1 Then	'if the current index is the last one
			Main.CurrentIndex = Main.CurrentIndex - 1			'decrement it by 1
		End If
		Main.RowNumber = Main.RowNumber - 1							'decrement the row count by 1
		ShowEntry(Main.CurrentIndex)										'show the next entry
		ToastMessageShow("Entry deleted", False)				'confirmation for the user
		ShowButtons
	End If
End Sub

Sub UpdateEntry
	Dim Query As String
	Dim i As Int
	Dim Values As List
	
	Values.Initialize
	Query = "UPDATE " & Main.SQLTabelName & " Set "
	For i = 1 To Main.ColNumber - 1
		If i = 1 Then
			Query = Query & Main.ColNames(i) & " = ?"
		Else
			Query = Query & ", " & Main.ColNames(i) & " = ?"
		End If
		Values.Add(edt(i).Text)
	Next
	Query = Query & " WHERE " & Main.ColNames(0) & " = " & Main.IDList.Get(Main.CurrentIndex)
	Main.SQL1.ExecNonQuery2(Query, Values)
	ToastMessageShow("Entry updated", False)
End Sub

Sub btnAdd_Click
	AddEntry
	Mode = "Edit"
	ShowButtons
End Sub

Sub btnDelete_Click
	DeleteEntry
End Sub

Sub btnUpdate_Click
	UpdateEntry
End Sub

Sub btnPrevious_Click
	If Main.CurrentIndex > 0 Then
		Main.CurrentIndex = Main.CurrentIndex - 1
		ShowEntry(Main.CurrentIndex)
	End If
End Sub

Sub btnNext_Click
	If Main.CurrentIndex < Main.RowNumber - 1 Then
		Main.CurrentIndex = Main.CurrentIndex + 1
		ShowEntry(Main.CurrentIndex)
	End If
End Sub

Sub btnFirst_Click
	Main.CurrentIndex = 0
	ShowEntry(Main.CurrentIndex)
End Sub

Sub btnLast_Click
	Main.CurrentIndex = Main.IDList.Size - 1
	ShowEntry(Main.CurrentIndex)
End Sub

Sub ShowButtons
	If Mode = "Add" Then
		btnPrevious.Visible = False		'hide the navigation buttons
		btnNext.Visible = False
		btnFirst.Visible = False
		btnLast.Visible = False
		btnDelete.Visible = False
		btnUpdate.Visible = False
	Else
		btnDelete.Visible = True
		btnUpdate.Visible = True
		If Main.RowNumber <= 1 Then 		'check if the database has less than 2 empty
			btnPrevious.Visible = False		'hide the navigation buttons
			btnNext.Visible = False
			btnFirst.Visible = False
			btnLast.Visible = False
		Else
			'show or hide the Previous and Next buttons depending on the value of the current index
			If Main.CurrentIndex = 0 Then			
				btnPrevious.Visible = False
				btnFirst.Visible = False
			Else
				btnPrevious.Visible = True
				btnFirst.Visible = True
			End If
			
			If Main.CurrentIndex = Main.IDList.Size - 1 Then
				btnNext.Visible = False
				btnLast.Visible = False
			Else
				btnNext.Visible = True
				btnLast.Visible = True
			End If
		End If
	End If
End Sub

Sub InitEditPanel
	Dim lbl(Main.ColNumber) As Label
	Dim edt(Main.ColNumber) As EditText
	
	Dim Height = 50dip As Int
	Dim VSpace = Height + 10dip As Int
	Dim lblLeft = 10dip As Int
	Dim lblWidth = 30%x - 10dip As Int
	Dim edtLeft = 30%x + 10dip As Int
	Dim edtWidth = 70%x - 20dip As Int
	Dim i As Int
	
	For i = 0 To Main.ColNumber - 1
		lbl(i).Initialize("")
		scvEdit.Panel.AddView(lbl(i), lblLeft, 10dip + i * VSpace, lblWidth, Height)
		lbl(i).Tag = i
		lbl(i).Gravity = Bit.OR(Gravity.RIGHT, Gravity.CENTER_VERTICAL)
		lbl(i).TextSize = 16
		lbl(i).Text = Main.ColAliasNames(i)
		lbl(i).TextColor = Colors.Yellow
		
		edt(i).Initialize("edt")
		scvEdit.Panel.AddView(edt(i), edtLeft, 10dip + i * VSpace, edtWidth, Height)
		edt(i).Tag = i
		edt(i).TextColor = Colors.Black
	Next
	edt(0).Enabled = False
	scvEdit.Panel.Height = 10dip + i * VSpace
End Sub
