﻿Type=Activity
Version=3.5
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'variable for the filter query, 
	'defined in the btnFilter_Click routine
	'and will be used In the DBWebView ShowTable routine
	Dim Query = "" As String
	
	' flag for the filter active or inactive
	Dim flagFilterActive = False As Boolean
	
	' Boolean operator used in the filter
	' can be OR or AND
'	Dim BooleanOperator = "OR " As String
	Dim BooleanOperator = "AND " As String
	
	' Variables used to hold the selected indexes of the Spinners
	Dim SelectedItemIndex() As Int
End Sub

Sub Globals
	Dim scvFilter As ScrollView
	Dim spnItems() As Spinner
	Dim lblItems() As Label
	Dim btnFilter, btnBooleanOperator As Button
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("Filter")
	Activity.Title = "SQLiteLight2  Filter"

	Dim spnItems(Main.ColNumber) As Spinner
	Dim lblItems(Main.ColNumber) As Label
	If SelectedItemIndex.Length = 0 Then
		Dim SelectedItemIndex(Main.ColNumber) As Int
	End If
	InitSpinners
End Sub

Sub Activity_Resume
	'set the text of the btnBooleanOperator button
	btnBooleanOperator.Text = BooleanOperator

'	'set the last selected indexes of the Spinners
	Dim col As Int
	For col = 1 To Main.ColNumber - 1
		spnItems(col).SelectedIndex = SelectedItemIndex(col)
		spnItemClick(col, SelectedItemIndex(col))
	Next
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub btnFilter_Click
	Query = GetFilterQuery
	
	'set the filter to active
	flagFilterActive = True
	
	'quit the Activity, returns to the DBWebView Activity
	Activity.Finish
End Sub

Sub GetFilterQuery As String
	'a query will look like something
	' WHERE FirstName = 'John'
	' WHERE FirstName = 'John' AND LastName = 'KENNEDY'
	' WHERE FirstName = 'John' AND City = 'London'
	' WHERE FirstName = 'John' AND LastName = 'KENNEDY' AND City = 'London'
	'the single quotes are needed because the values are strings

	Dim Query1 = " WHERE " As String	'beginning of the query1
	
	Dim col As Int
	For col = 1 To Main.ColNumber - 1
		If SelectedItemIndex(col) > 0 Then
			If col = 1 Then
				Query1 = Query1 & Main.ColNames(col) & " = '" & spnItems(col).SelectedItem & "' "
			Else
				If Query1 = " WHERE " Then
					Query1 = Query1 & Main.ColNames(col) & " = '" & spnItems(col).SelectedItem & "' "
				Else
					Query1 = Query1 & BooleanOperator & Main.ColNames(col) & " = '" & spnItems(col).SelectedItem & "' "
				End If
			End If
		End If
	Next
	
	'if nothing was selected set Query = ""
	If Query1 = " WHERE " Then
		Query1 = ""
	End If
	
	Return Query1
End Sub

Sub btnBooleanOperator_Click
	'selects the boolean operator and changes the text in the button
	If btnBooleanOperator.Text = "OR " Then
		btnBooleanOperator.Text = "AND "
		BooleanOperator = "AND "
	Else
		btnBooleanOperator.Text = "OR "
		BooleanOperator = "OR "
	End If
End Sub

'Initialize the Spinners
Sub InitSpinners
	Dim col, col_1 As Int
	Dim lblHeight = 30dip As Int
	Dim spnHeight = 50dip As Int
	Dim Width = 250dip As Int
	Dim Left = (scvFilter.Width - Width) / 2
	Dim VSpace = 20dip + lblHeight + spnHeight

	For col = 1 To Main.ColNumber - 1
		 col_1 = col - 1
		lblItems(col).Initialize("lblItems")
		scvFilter.Panel.AddView(lblItems(col), Left, 20dip + col_1 * VSpace, Width, lblHeight)
		lblItems(col).TextSize = 16
		lblItems(col).Text = Main.ColAliasNames(col)
		
		spnItems(col).Initialize("spnItems")
		scvFilter.Panel.AddView(spnItems(col), Left, 20dip + lblHeight + col_1 * VSpace, Width, spnHeight)
		spnItems(col).Tag = col
		UpdateSpinner(col, False)
	Next
End Sub

Sub spnItems_ItemClick(Position As Int, Value As Object)
	Dim spn As Spinner
	Dim i, col As Int
	
	spn = Sender
	col =  spn.Tag
	
	spnItemClick(col, Position)
End Sub

Sub spnItemClick(col As Int, Position As Int)
	Dim i As Int
	SelectedItemIndex(col) = Position
End Sub

Sub UpdateSpinner(col As Int, Filter As Boolean)
	Dim Query1 As String
	
'	Query1 = "SELECT DISTINCT " & Main.ColNames(col) & " FROM " & Main.SQLTabelName
	Query1 = "SELECT DISTINCT " & Main.ColNames(col) & " FROM " & Main.SQLTabelName & " ORDER BY " & Main.ColNames(col) & " ASC"
	
	spnItems(col).Clear
	spnItems(col).Add("no filter")
	
	Dim Curs2 As Cursor
	Curs2 = Main.SQL1.ExecQuery(Query1)
	
	For i = 0 To Curs2.RowCount - 1
		Curs2.Position = i
		spnItems(col).Add(Curs2.GetString(Main.ColNames(col)))
	Next

	Curs2.Close
End Sub

Sub InitScrollView
	For col = 0 To Main.ColNumber - 1
		lblItems(col).Initialize("spnItems")
		
		spnItems(col).Initialize("spnItems")
	Next
End Sub

